VERSION 5.00
Begin VB.Form frmOD 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Outlook Deleter"
   ClientHeight    =   3360
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3675
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3360
   ScaleWidth      =   3675
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdDAll 
      Caption         =   "Delete All"
      Enabled         =   0   'False
      Height          =   315
      Left            =   75
      TabIndex        =   5
      Top             =   3000
      Width           =   1215
   End
   Begin VB.CommandButton cmdBack 
      Caption         =   "Back"
      Enabled         =   0   'False
      Height          =   315
      Left            =   2325
      TabIndex        =   2
      Top             =   0
      Width           =   1290
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Height          =   315
      Left            =   75
      TabIndex        =   1
      Top             =   0
      Width           =   1290
   End
   Begin VB.ListBox l1 
      Height          =   2010
      Left            =   75
      TabIndex        =   0
      Top             =   675
      Width           =   3540
   End
   Begin VB.Label lb2 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000018&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "(c) John Colman - 2001"
      ForeColor       =   &H80000008&
      Height          =   240
      Left            =   75
      TabIndex        =   4
      Top             =   2700
      Width           =   3540
   End
   Begin VB.Label lb1 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H8000000D&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Click Start to Begin"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H8000000E&
      Height          =   240
      Left            =   75
      TabIndex        =   3
      Top             =   375
      Width           =   3540
   End
End
Attribute VB_Name = "frmOD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim o1 As Outlook.Application
Dim f1 As Outlook.MAPIFolder

Private Sub cmdBack_Click()
    'Go back depends on where to go back to
    If TypeOf f1.Parent Is Outlook.NameSpace Then
        Set f1 = Nothing
    Else
        Set f1 = f1.Parent
    End If
    
    'Show sub folders etc.
    FindFolders
End Sub

Private Sub cmdDAll_Click()
    Dim I As Integer
    If MsgBox("Are you sure you want to do this?", vbQuestion + vbYesNo, "Don't do it!") = vbNo Then Exit Sub
    If MsgBox("Really?", vbQuestion + vbYesNo, "Think about it!") = vbNo Then Exit Sub
    If MsgBox("So that's it then?", vbQuestion + vbYesNo, "Last chance!") = vbNo Then Exit Sub
    
    
    If Not f1 Is Nothing Then
        For I = f1.Items.Count To 1 Step -1
            'Note: You can put some filtering code here if you only want to delete certain items
            f1.Items(I).Delete
        Next
    End If
    FindFolders
End Sub

Private Sub cmdStart_Click()
    'Can't restart
    cmdStart.Enabled = False
    'Open outlook
    Set o1 = New Outlook.Application
    'Get sub folders at root
    FindFolders
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'This frees up some resources
    Set o1 = Nothing
    Set f1 = Nothing
End Sub

Private Sub FindFolders(Optional s1 As String = vbNullString)
    Dim f2 As Outlook.MAPIFolder
    'On Error Resume Next
    
    'Clear the list box
    l1.Clear
    
    'If called with folder name, dig to folder
    If s1 <> vbNullString Then
        If f1 Is Nothing Then
            Set f1 = o1.GetNamespace("MAPI").Folders.Item(s1)
        Else
            Set f1 = f1.Folders.Item(s1)
        End If
    End If
    
    'Show sub folders
    If f1 Is Nothing Then
        For Each f2 In o1.GetNamespace("MAPI").Folders
            l1.AddItem f2.Name
        Next
        lb1.Caption = "Start"
        lb2.Caption = vbNullString
        cmdDAll.Enabled = False
    Else
        For Each f2 In f1.Folders
            l1.AddItem f2.Name
        Next
        lb1.Caption = f1.Name
        lb2.Caption = f1.Items.Count & " items"
        cmdDAll.Enabled = True
    End If
    
    'Enable/disable the back button
    SetBack
    
    'Clean up
    Set f2 = Nothing
End Sub

Private Sub l1_DblClick()
    'Get sub folder
    FindFolders l1.Text
End Sub

Private Sub SetBack()
    'Enable button when can go back
    If Not f1 Is Nothing Then
        If TypeOf f1.Parent Is Outlook.MAPIFolder Or TypeOf f1.Parent Is Outlook.NameSpace Then
            cmdBack.Enabled = True
        Else
            cmdBack.Enabled = False
        End If
    Else
        cmdBack.Enabled = False
    End If
End Sub
